﻿
using HarmonyLib;
using TenCrowns.AppCore;
using TenCrowns.GameCore;
using Mohawk.SystemCore;
using System;
using UnityEngine;

namespace SettleAnywhere
{
    public class SettleAnywhereClass : ModEntryPointAdapter
    {
        public override void Initialize(ModSettings modSettings)
        {
            Harmony harmony = new Harmony("oldworld.SettleAnywhere.patch");
            harmony.PatchAll();
        }
    }

    [HarmonyPatch(typeof(Tile), nameof(Tile.isValidFoundLocation), new Type[] { typeof(TeamType), typeof(TeamType) })]

    public class PatchSettleAnywhereClass
    {
        static bool Prefix(ref bool __result, Tile __instance, TeamType eTeam, TeamType eVisibilityTeam)
        {
            using (new UnityProfileScope("Tile.isValidFoundLocation"))
            {
                if (__instance.getRevealedCityTerritory(eVisibilityTeam) != -1)
                {
//                    Debug.Log((object)"isValidFoundLocation getRevealedCityTerritory == false");
                    __result = false;
                }
                if (__instance.game().getTurn() < 2)
                {
                    if (!__instance.isRevealedCitySiteActive(eVisibilityTeam) && !__instance.isRevealedUrban(eVisibilityTeam))
                    {
                        __result = false;
                    }
                }
                if (__instance.isConnectedNoFound(eTeam, eVisibilityTeam))
                {
//                    Debug.Log((object)"isValidFoundLocation isConnectedNoFound == false");
                    __result = false;
                }
//                Debug.Log((object)"isValidFoundLocation == true");
                __result = true;
                return false;
            }
        }
    }
}
